local _G = _G
local unpack, string = unpack, string

function MacroToolkit:LoadElvSkin()
	local E, L, V, P, G, _ = unpack(ElvUI)
	local S = E:GetModule("Skins")

	if E.private.skins.blizzard.enable ~= true or E.private.skins.blizzard.macro ~= true then return end
	S:HandleCloseButton(MacroToolkitFrameCloseButton)
	S:HandleCloseButton(MacroToolkitScriptFrameCloseButton)
	S:HandleCloseButton(MacroToolkitBuilderFrameCloseButton)
	S:HandleScrollBar(MacroToolkitButtonScrollScrollBar)
	S:HandleScrollBar(MacroToolkitScrollFrameScrollBar)
	S:HandleScrollBar(MacroToolkitFauxScrollFrameScrollBar)
	S:HandleScrollBar(MacroToolkitErrorScrollFrameScrollBar)
	--S:HandleScrollBar(MacroToolkitPopupScrollScrollBar)
	S:HandleScrollBar(MacroToolkitPopupIcons.scrollFrame.ScrollBar)
	S:HandleScrollBar(MacroToolkitScriptScrollScrollBar)
	S:HandleScrollBar(MacroToolkitScriptErrorsScrollBar)

	MacroToolkitFrame:Width(648)
	MacroToolkitScriptFrame:Height(428)

	local buttons = {
		"MacroToolkitSave", "MacroToolkitCancel", "MacroToolkitDelete", "MacroToolkitNew", "MacroToolkitExit", "MacroToolkitEdit",
		"MacroToolkitFrameTab1", "MacroToolkitFrameTab2", "MacroToolkitPopupOk", "MacroToolkitPopupCancel", "MacroToolkitShorten",
		"MacroToolkitAddScript", "MacroToolkitAddSlot", "MacroToolkitBackup", "MacroToolkitRestore", "MacroToolkitClear",
		"MacroToolkitShare", "MacroToolkitRestoreRestore", "MacroToolkitRestoreCancel", "MacroToolkitRestoreDelete",
		"MacroToolkitCustom", "MacroToolkitScriptExit", "MacroToolkitScriptDelete", "MacroToolkitScriptSave", "MacroToolkitExtend",
		"MacroToolkitOpen", "MacroToolkitConditions", "MacroToolkitBuilderCancel", "MacroToolkitBuilderInsert", "MacroToolkitOptionsButton",
		"MacroToolkitMacroBox",
	}

	for i = 1, #buttons do
		_G[buttons[i]]:StripTextures()
		S:HandleButton(_G[buttons[i]])
	end

	MacroToolkitFlyout:Size(MacroToolkitFlyout:GetWidth() - 7, MacroToolkitFlyout:GetHeight() - 7)
	S:HandleNextPrevButton(MacroToolkitFlyout)
	MacroToolkitFlyout:ClearAllPoints()
	MacroToolkitFlyout:SetPoint("TOPRIGHT", -4, -34)
	MacroToolkitCustom:SetPoint("TOPRIGHT", MacroToolkitFlyout, "TOPLEFT", -4, 2)

	for i = 1, 2 do
		local tab = _G[string.format("MacroToolkitFrameTab%s", i)]
		tab:Height(22)
	end

	MacroToolkitFrameTab1:SetPoint("TOPLEFT", MacroToolkitFrame, "TOPLEFT", 85, -39)
	MacroToolkitFrameTab2:SetPoint("LEFT", MacroToolkitFrameTab1, "RIGHT", 4, 0)
	MacroToolkitFrame:StripTextures()
	MacroToolkitFrame:SetTemplate("Transparent")
	MacroToolkitFrameInset:Kill()
	MacroToolkitTextBg:StripTextures()
	MacroToolkitTextBg:SetTemplate("Default")
	MacroToolkitErrorBg:StripTextures()
	MacroToolkitErrorBg:SetTemplate("Default")
	MacroToolkitButtonScroll:StripTextures()
	MacroToolkitButtonScroll:CreateBackdrop()
	MacroToolkitPopup:StripTextures()
	MacroToolkitPopup:SetTemplate("Transparent")
	--MacroToolkitPopupScroll:StripTextures()
	--MacroToolkitPopupScroll:CreateBackdrop()
	--MacroToolkitPopupScroll.backdrop:SetPoint("TOPLEFT", 51, 2)
	--MacroToolkitPopupScroll.backdrop:SetPoint("BOTTOMRIGHT", -4, 4)
	MacroToolkitPopupIcons:StripTextures()
	MacroToolkitPopupIcons:CreateBackdrop()
	MacroToolkitPopupIcons.backdrop:SetPoint("TOPLEFT", 10, 2)
	MacroToolkitPopupIcons.backdrop:SetPoint("BOTTOMRIGHT", -4, -16)
	S:HandleEditBox(MacroToolkitPopupEdit)
	S:HandleEditBox(MacroToolkitSearchBox)
	MacroToolkitRestoreFrame:StripTextures()
	MacroToolkitRestoreFrame:SetTemplate("Transparent")
	MacroToolkitScriptFrame:StripTextures()
	MacroToolkitScriptFrame:SetTemplate("Transparent")
	MacroToolkitScriptFrameInset:Kill()
	MacroToolkitScriptScrollBg:StripTextures()
	MacroToolkitScriptScrollBg:SetTemplate("Default")
	MacroToolkitScriptErrorBg:StripTextures()
	MacroToolkitScriptErrorBg:SetTemplate("Default")
	MacroToolkitScriptScroll:StripTextures()
	MacroToolkitScriptScroll:CreateBackdrop()
	MacroToolkitScriptErrors:StripTextures()
	MacroToolkitScriptErrors:CreateBackdrop()
	MacroToolkitBuilderFrame:StripTextures()
	MacroToolkitBuilderFrame:SetTemplate("Transparent")
	MacroToolkitBuilderFrameInset:Kill()
	
	MacroToolkitEdit:ClearAllPoints()
	MacroToolkitEdit:SetPoint("BOTTOMLEFT", MacroToolkitSelMacroButton, "BOTTOMRIGHT", 10, 0)
	MacroToolkitNew:ClearAllPoints()
	MacroToolkitNew:SetPoint("BOTTOMRIGHT", -90, 4)
	MacroToolkitExtend:ClearAllPoints()
	MacroToolkitExtend:SetPoint("LEFT", MacroToolkitDelete, "RIGHT", 80, 0)
	MacroToolkitShorten:ClearAllPoints()
	MacroToolkitShorten:SetPoint("LEFT", MacroToolkitExtend, "RIGHT", 4, 0)
	MacroToolkitScriptSave:ClearAllPoints()
	MacroToolkitScriptSave:SetPoint("BOTTOMRIGHT", -92, 4)
	MacroToolkitScriptExit:ClearAllPoints()
	MacroToolkitScriptExit:SetPoint("BOTTOMRIGHT", -7, 4)
	MacroToolkitScriptDelete:ClearAllPoints()
	MacroToolkitScriptDelete:SetPoint("BOTTOMLEFT", 7, 4)
	MacroToolkitScriptEnter:SetPoint("TOPLEFT", 10, -44)
	MacroToolkitScriptErrorBg:ClearAllPoints()
	MacroToolkitScriptErrorBg:SetPoint("BOTTOMLEFT", 7, 31)
	MacroToolkitErrorBg:ClearAllPoints()
	MacroToolkitErrorBg:SetPoint("TOPLEFT", 338, -289)
	MacroToolkitEnterText:ClearAllPoints()
	MacroToolkitEnterText:SetPoint("TOPLEFT", MacroToolkitSelBg, "BOTTOMLEFT", 8, 8)
	MacroToolkitErrorLabel:ClearAllPoints()
	MacroToolkitErrorLabel:SetPoint("BOTTOMLEFT", MacroToolkitErrorScrollFrame, "TOPLEFT", -3, 10)
	S:HandleScrollBar(MacroToolkitButtonScroll)
	MacroToolkitPopupCancel:ClearAllPoints()
	MacroToolkitPopupCancel:SetPoint("BOTTOMRIGHT", -11, 9)
	MacroToolkitPopupOk:ClearAllPoints()
	MacroToolkitPopupOk:SetPoint("RIGHT", MacroToolkitPopupCancel, "LEFT", -6, 0)
	MacroToolkitFramePopupL:SetTexture(nil)
	MacroToolkitFramePopupM:SetTexture(nil)
	MacroToolkitFramePopupR:SetTexture(nil)
	MacroToolkitBuilderInsert:ClearAllPoints()
	MacroToolkitBuilderInsert:SetPoint("RIGHT", MacroToolkitBuilderCancel, "LEFT", -4, 0)
	MacroToolkitOptionsButton:ClearAllPoints()
	MacroToolkitOptionsButton:SetPoint("LEFT", MacroToolkitConditions, "RIGHT", 23, 0)

	MacroToolkitPopup:HookScript("OnShow", function(self)
		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", MacroToolkitFrame, "TOPRIGHT", 5, -2)
	end)

	MacroToolkitRestoreFrame:HookScript("OnShow", function(self)
		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", MacroToolkitFrame, "TOPRIGHT", 5, -2)
	end)

	MacroToolkitSelMacroButton:StripTextures()
	MacroToolkitSelMacroButton:StyleButton(true)
	MacroToolkitSelMacroButton:GetNormalTexture():SetTexture(nil)
	MacroToolkitSelMacroButton:SetTemplate("Default")
	MacroToolkitSelMacroButtonIcon:SetTexCoord(unpack(E.TexCoords))
	MacroToolkitSelMacroButtonIcon:SetInside()

	MacroToolkitLimit:ClearAllPoints()
	MacroToolkitLimit:SetPoint("BOTTOM", MacroToolkitTextBg, 0, -12)

	for i = 1, _G.MAX_ACCOUNT_MACROS do
		local b = _G["MacroToolkitButton" .. i]
		local t = _G["MacroToolkitButton" .. i .."Icon"]
		local pb = _G["MacroToolkitPopupButton" .. i]
		local pt = _G["MacroToolkitPopupButton" .. i .."Icon"]
		if b then
			b:StripTextures()
			b:StyleButton(true)
			b:SetTemplate("Default", true)
		end
		if t then
			t:SetTexCoord(unpack(E.TexCoords))
			t:SetInside()
		end
		if pb then
			pb:StripTextures()
			pb:StyleButton(true)
			pb:SetTemplate("Default")					
		end
		if pt then
			pt:SetTexCoord(unpack(E.TexCoords))
			pt:SetInside()
		end
	end
	S:RegisterSkin("MacroToolkit", LoadSkin)
end